/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.personenpruefung.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="PERSON_PRUEFUNG_KONFIGURATION.UK",
     query="SELECT o FROM PersonPruefungKonfiguration o WHERE "

                         + "o"
                +".personentyp"
              +" = ?1"

             +" AND "         + "o"
                +".typ"
              +" = ?2"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?3"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?5"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?6"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?7"

             +" AND "         + "o"
                +".wahltermin"
                +".nummer"
              +" = ?8"

             +" AND "         + "o"
                +".wahltermin"
                +".wahldatum"
              +" = ?9"

             +" AND "         + "o"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?10"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="PERSON_PRUEFUNG_KONFIGURATION.Wahl",
     query="SELECT o FROM PersonPruefungKonfiguration o WHERE o.wahl=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="PERSON_PRUEFUNG_KONFIGURATION.Wahltermin",
     query="SELECT o FROM PersonPruefungKonfiguration o WHERE o.wahltermin=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "PERSON_PRUEFUNG_KONFIGURATION")
// @javax.persistence.IdClass(PersonPruefungKonfigurationPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class PersonPruefungKonfiguration
extends AbstractPersonPruefungKonfiguration
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected PersonPruefungKonfiguration() {
    super();
  }
    public PersonPruefungKonfiguration(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public PersonPruefungKonfiguration(PersonPruefungKonfiguration original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "person_pruefung_konfigurati_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "PersonPruefungKonfiguration")
    @javax.persistence.TableGenerator(name = "PersonPruefungKonfiguration", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "PersonPruefungKonfiguration", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient PersonPruefungKonfigurationPK pkCache;

  @Override
  public PersonPruefungKonfigurationPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new PersonPruefungKonfigurationPK(getId());
    }

    return pkCache;
  }

  public static <E extends PersonPruefungKonfiguration> java.util.Map<PersonPruefungKonfigurationPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<PersonPruefungKonfigurationPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends PersonPruefungKonfiguration> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedBeschreibung = false;
          hasChangedName = false;
          hasChangedPersonentyp = false;
          hasChangedStatus = false;
          hasChangedTyp = false;
  
      hasChangedCustomDataStorage = false;
        hasChangedWahltermin = false;
        hasChangedWahl = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BESCHREIBUNG", nullable = PersonPruefungKonfigurationConstants.BESCHREIBUNG_NULLABLE, length=PersonPruefungKonfigurationConstants.BESCHREIBUNG_MAX_LENGTH)
        
  protected java.lang.String beschreibung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBeschreibung = false;

  public boolean hasChangedBeschreibung(){
    return hasChangedBeschreibung;
  }
  
  /**
   * 
   *
   * getter for PERSON_PRUEFUNG_KONFIGURATION.BESCHREIBUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBeschreibung() {
        return beschreibung;
      }

  /**
   * 
   *
   * setter for PERSON_PRUEFUNG_KONFIGURATION.BESCHREIBUNG
   *
   * @param beschreibung
   */
  @Override   public void setBeschreibung(@javax.annotation.Nullable  java.lang.String beschreibung) {

       resetTkCache();
                  
                          java.lang.String beschreibungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(beschreibung, PersonPruefungKonfigurationConstants.BESCHREIBUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.beschreibung
      , beschreibungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBeschreibung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("beschreibung");
      }


      

       this.beschreibung = beschreibungInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = PersonPruefungKonfigurationConstants.NAME_NULLABLE, length=PersonPruefungKonfigurationConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
  
  /**
   * 
   *
   * getter for PERSON_PRUEFUNG_KONFIGURATION.NAME
   */
    @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for PERSON_PRUEFUNG_KONFIGURATION.NAME
   *
   * @param name
   */
  @Override   public void setName( java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, PersonPruefungKonfigurationConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


      

       this.name = nameInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PERSONENTYP", nullable = PersonPruefungKonfigurationConstants.PERSONENTYP_NULLABLE)
    
  protected de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationPersonentyp personentyp =  de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationPersonentyp.ALLE;

  @javax.persistence.Transient
  protected boolean hasChangedPersonentyp = false;

  public boolean hasChangedPersonentyp(){
    return hasChangedPersonentyp;
  }
  
  /**
   * 
   *
   * getter for PERSON_PRUEFUNG_KONFIGURATION.PERSONENTYP
   */
    @Override   public  de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationPersonentyp getPersonentyp() {
        return personentyp;
      }

  /**
   * 
   *
   * setter for PERSON_PRUEFUNG_KONFIGURATION.PERSONENTYP
   *
   * @param personentyp
   */
  @Override   public void setPersonentyp( de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationPersonentyp personentyp) {

       resetTkCache();
                  de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationPersonentyp personentypInternal = personentyp;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.personentyp
      , personentypInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPersonentyp |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("personentyp");
      }


      

       this.personentyp = personentypInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = PersonPruefungKonfigurationConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationStatus status =  de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationStatus.AKTIVIERT_DEFAULT;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
  
  /**
   * 
   *
   * getter for PERSON_PRUEFUNG_KONFIGURATION.STATUS
   */
    @Override   public  de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for PERSON_PRUEFUNG_KONFIGURATION.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationStatus status) {

       resetTkCache();
                  de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


      

       this.status = statusInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "TYP", nullable = PersonPruefungKonfigurationConstants.TYP_NULLABLE)
    
  protected de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationTyp typ =  null;

  @javax.persistence.Transient
  protected boolean hasChangedTyp = false;

  public boolean hasChangedTyp(){
    return hasChangedTyp;
  }
  
  /**
   * 
   *
   * getter for PERSON_PRUEFUNG_KONFIGURATION.TYP
   */
    @Override   public  de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationTyp getTyp() {
        return typ;
      }

  /**
   * 
   *
   * setter for PERSON_PRUEFUNG_KONFIGURATION.TYP
   *
   * @param typ
   */
  @Override   public void setTyp( de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationTyp typ) {

       resetTkCache();
                  de.ivu.elect.business.personenpruefung.entity.PersonPruefungKonfigurationTyp typInternal = typ;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.typ
      , typInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedTyp |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("typ");
      }


      

       this.typ = typInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }

  /**
   * Beziehung (unidirektional) zu Wahltermin
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLTERMIN_ID", referencedColumnName="WAHLTERMIN_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahltermin wahltermin;

  /**
   * 
   */
  @Override
  public void setWahltermin( de.ivu.elect.business.wahl.entity.Wahltermin wahltermin){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahltermin
    , wahltermin);

    attributeChanged |= thisAttributChanged;

    hasChangedWahltermin |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahltermin");
    }

    this.wahltermin = wahltermin;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahltermin getWahltermin(){
    return this.wahltermin;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahltermin = false;

  public boolean hasChangedWahltermin(){
    return hasChangedWahltermin;
  }

  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl(@javax.annotation.Nullable  de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("PersonPruefungKonfiguration:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(PersonPruefungKonfiguration other){
                             other.beschreibung = this.beschreibung;
                                other.name = this.name;
                                other.personentyp = this.personentyp;
                                other.status = this.status;
                                other.typ = this.typ;
           
  other.setCustomDataStorage(this.getCustomDataStorage());
  other.setWahltermin(this.getWahltermin());
  other.setWahl(this.getWahl());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(PersonPruefungKonfiguration.class)){
        copyEntityAttributesUsingSetter((PersonPruefungKonfiguration) other.castTo(PersonPruefungKonfiguration.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von PersonPruefungKonfiguration: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(PersonPruefungKonfiguration other){
               other.setBeschreibung(this.beschreibung);
                  other.setName(this.name);
                  other.setPersonentyp(this.personentyp);
                  other.setStatus(this.status);
                  other.setTyp(this.typ);
           other.setCustomDataXml(this.getCustomDataXml());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(PersonPruefungKonfiguration other){
                       if (hasChangedBeschreibung) {
        other.setBeschreibung(this.beschreibung);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
                             if (hasChangedPersonentyp) {
        other.setPersonentyp(this.personentyp);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedTyp) {
        other.setTyp(this.typ);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität PersonPruefungKonfiguration besitzt kein CustomDataStorage: "+this);
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    @Override
    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    @Override
    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität PersonPruefungKonfiguration hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität PersonPruefungKonfiguration hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität PersonPruefungKonfiguration hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität PersonPruefungKonfiguration hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient PersonPruefungKonfigurationTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public PersonPruefungKonfigurationTK getPersonPruefungKonfigurationTK(){
    if (tkCache==null) {
    tkCache = new PersonPruefungKonfigurationTK(

getPersonentyp()
, getTyp()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getPersonPruefungKonfigurationTK();
    }

  @Override
  public PersonPruefungKonfigurationUK getUk(){
    return getPersonPruefungKonfigurationUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return PersonPruefungKonfiguration.class;
  }

public PersonPruefungKonfigurationUK getPersonPruefungKonfigurationUK(){

   return  new PersonPruefungKonfigurationUK(

getPersonentyp()
, getTyp()
,     getWahl()==null?null:getWahl().getWahlUK()
,     getWahltermin()==null?null:getWahltermin().getWahlterminUK()


  );
}

  @javax.persistence.Transient
  private transient PersonPruefungKonfigurationProperties properties;

  public PersonPruefungKonfigurationProperties getProperties(){
    if (properties == null) {
      properties = new PersonPruefungKonfigurationProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public PersonPruefungKonfigurationProperties getPersonPruefungKonfigurationProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return PersonPruefungKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                                 }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                                                                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "PERSON_PRUEFUNG_KONFIGURATION";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "PersonPruefungKonfiguration";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(PersonPruefungKonfigurationConstants.BESCHREIBUNG_MAX_LENGTH ,  beschreibung, this, PersonPruefungKonfigurationConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, PersonPruefungKonfigurationConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(PersonPruefungKonfigurationConstants.NAME_MAX_LENGTH , 1 ,  name, this, PersonPruefungKonfigurationConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(personentyp, this, PersonPruefungKonfigurationConstants.MESSAGE_KEY_PERSONENTYP_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, PersonPruefungKonfigurationConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(typ, this, PersonPruefungKonfigurationConstants.MESSAGE_KEY_TYP_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
